<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="ifAlone==null?aloneFormRules:formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-select v-model="formData.supplierId" filterable placeholder="请选择">
          <el-option
            v-for="dict in supplierList"
            :key="dict.id"
            :label="dict.name"
            :value="dict.id"
          />
        </el-select>
        </el-form-item>
      <el-form-item label="证件类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SUPPLIER_CERT)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="证件名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入证件名称" />
      </el-form-item>
      <el-form-item label="附件" prop="urls">
        <UploadFile :is-show-tip="false" v-model="formData.urls" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script lang="ts" setup>
import {DICT_TYPE, getIntDictOptions, getStrDictOptions} from '@/utils/dict'
import { CertificateApi, CertificateVO } from '@/api/supplier/certificate'
import * as SupplierBaseApi from '@/api/supplier/base'
import { SupplierVO } from '@/api/supplier/base'
import { FormRules } from 'element-plus'

/** 供应商证件资质 表单 */
defineOptions({ name: 'CertificateForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const supplierList = ref([] as SupplierVO[])
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  supplierId: undefined,
  supplierName: undefined,
  type: undefined,
  name: undefined,
  urls: undefined
})
const formRules = reactive<FormRules>({
  // supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  type: [{ required: true, message: '证件类型不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '证件名称不能为空', trigger: 'blur' }]
})
const aloneFormRules = reactive<FormRules>({
  supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  type: [{ required: true, message: '证件类型不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '证件名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const props = defineProps({
  supplierId: { type: Number, default: () => null },
  ifAlone: { type: Boolean, default: () => null },
})
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CertificateApi.getCertificate(id)
    } finally {
      formLoading.value = false
    }
  }
  supplierList.value = await SupplierBaseApi.Api.getAll()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CertificateVO
    // const supplier = data.supplierId
    if (props.ifAlone!=null) {
      if (!props.supplierId.receivedParam){
        message.error("请先保存供应商基本信息");
        return
      }
      data.supplierId = props.supplierId.receivedParam
    }

    // data.supplierName = supplier.name

    if (data.urls) {
      if (Array.isArray(data.urls)) {
        data.urls = data.urls.join(',')
      }
    }
    if (formType.value === 'create') {
      await CertificateApi.createCertificate(data)
      message.success(t('common.createSuccess'))
    } else {
      await CertificateApi.updateCertificate(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    supplierId: undefined,
    type: undefined,
    name: undefined,
    urls: undefined
  }
  formRef.value?.resetFields()
}
</script>
